#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <imsl.h>
#include <imsls.h>
#include "vmr.h"

int round(double x) {
  return (int)(x + 0.5);
}
int main(int argc, char **argv) {
int N=4583;
int J=7;
int R=64;
int K;
int num=1000;
int fixalphas=0;
int fixksi=0;
int fixgik=0;
int fixlambda=0;
int outscores=0;
int burnin=4000;
int thinlam=20;
int thinscores=200;
int ndraws=0;
double C1=80;
double A1=1;
double B1=1;
double C2=1;
double aSaccept=0;
double ksiaccept=0;
FILE *fout;
FILE *fexp;
FILE *fdirich;
FILE *fscores;
FILE *faccept;
FILE *floglikl;
FILE *fmscores;
FILE *fmexp;
FILE *stop;
FILE *meanout;
FILE *ftheta;
FILE *fspec;

double *alpha;
double **malpha;
double *ksi;
double *ksinew;
double rksi;
double alphaS;
double alphaSnew;
double ralphaS;
double sumXilogG;
double rgamma;
double **beta;
double *id;
double **X;
double **G;
double **Lam;
int **Z;
int **S;
double *pik,*p0,*p1;


double *fik;
double piksum;
double giksum;
double ksisum;
double *pij;

double u;
int **Nkj;
int **Ckj;

double **presp;
 
double *giknew;
double **respprob;
double *respprob0;
double *respprob1;
double **sumg;
double **sumLam;
double *sumksi;
double sumalphaS;
double *probr;
double probr0,probr1;
double *sumprobr;
double sumprob0,sumprob1;
double logp,L0,L1,Lm,L,Log0,Log1,Logm,L0sum,L1sum,Lmsum,sumXi;
int i, n, k, j, r, c;
int n0,m0,n1,m1;
int n0m,n0mnew,n1m,n1mnew,nmm;
double *sumX;
double theta1, theta2, theta3;
double **mtheta;
double *pij1,*pij2;

if (argc<2) {
printf("Error:number of extreme profiles needed.\n");
return(EXIT_FAILURE);
}

if (argc>1)
K=atoi(argv[1]);

if (argc>2)
num=atoi(argv[2]);

if (argc>3 && strcmp(argv[3],"fixalphas")==0)
fixalphas=1;
if (argc>3 && strcmp(argv[3],"fixksi")==0)
fixksi=1;
if (argc>3 && strcmp(argv[3],"fixgik")==0)
fixgik=1;
if (argc>3 && strcmp(argv[3],"fixlambda")==0)
fixlambda=1;
if (argc>3 && strcmp(argv[3],"outscores")==0)
outscores=1;
if (argc>4 && strcmp(argv[4],"fixalphas")==0)
fixalphas=1;
if (argc>4 && strcmp(argv[4],"fixksi")==0)
fixksi=1;
if (argc>4 && strcmp(argv[4],"fixgik")==0)
fixgik=1;
if (argc>4 && strcmp(argv[4],"fixlambda")==0)
fixlambda=1;
if (argc>4 && strcmp(argv[4],"outscores")==0)
outscores=1;
if (argc>5 && strcmp(argv[5],"fixalphas")==0)
fixalphas=1;

if (argc>5 && strcmp(argv[5],"fixksi")==0)
fixksi=1;
if (argc>5 && strcmp(argv[5],"fixgik")==0)
fixgik=1;
if (argc>5 && strcmp(argv[5],"fixlambda")==0)
fixlambda=1;
if (argc>5 && strcmp(argv[5],"outscores")==0)
outscores=1;
if (argc>6 && strcmp(argv[6],"fixalphas")==0)
fixalphas=1;
if (argc>6 && strcmp(argv[6],"fixksi")==0)
fixksi=1;
if (argc>6 && strcmp(argv[6],"fixgik")==0)
fixgik=1;
if (argc>6 && strcmp(argv[6],"fixlambda")==0)
fixlambda=1;
if (argc>6 && strcmp(argv[6],"outscores")==0)
outscores=1;
if (argc>7 && strcmp(argv[7],"fixalphas")==0)
fixalphas=1;
if (argc>7 && strcmp(argv[7],"fixksi")==0)
fixksi=1;
if (argc>7 && strcmp(argv[7],"fixgik")==0)
fixgik=1;
if (argc>7 && strcmp(argv[7],"fixlambda")==0)
fixlambda=1;
if (argc>7 && strcmp(argv[7],"outscores")==0)
outscores=1;



if (readfile("chlamidia.dat", &N, &J, &X)!=READFILE_OK) {
printf("Program is aborting.\n");
return(EXIT_FAILURE);
}

if (readfile("falpha2", &r, &c, &malpha)!=READFILE_OK) {
  mallocmat(VM_ERRQUIT, 1, &malpha, K, 1);
  for (k=0; k<K; k++) {
     malpha[k][0]=1.0;
  }
} else {
if (r!=K || c!=1) {
printf("Error: %s is not %d by 1.\n", "falpha2", K);
return(EXIT_FAILURE);
 }
}

alpha=malpha[0];

if (readfile("fbeta2", &r, &c, &beta)!=READFILE_OK) {
  mallocmat(VM_ERRQUIT, 1, &beta, K, J);
  for (k=0; k<K; k++) {
  for (j=0; j<J; j++) {
     beta[k][j]=1.0;
    }
  }
} else {
if (r!=K || c!=J) {
printf("Error: %s is not %d by %d.\n", "fbeta2", K, J);
return(EXIT_FAILURE);
   }
}



if (readfile("flamb2", &r, &c, &Lam)!=READFILE_OK) {
     printf("Program is aborting.\n");  
  return(EXIT_FAILURE);
  } 

if (r!=K || c!=J) {
printf("Error: %s is not %d by %d.\n", "flamb2", K, J);
return(EXIT_FAILURE);
  }



if (readfile("f2", &r, &c, &G)!=READFILE_OK) {
     printf("Program is aborting.\n");  
  return(EXIT_FAILURE);
  } 
if (r!=N || c!=K) {
printf("Error: %s is not %d by %d.\n", "f2", N, K);
return(EXIT_FAILURE);
  }

if (readfile("fprespchla", &R, &c, &presp)!=READFILE_OK) {
     printf("Program is aborting.\n");  
  return(EXIT_FAILURE);
  } 
if (c!=J+1) {
printf("Error: %s does not have %dcolumns.\n", "fpresp", J);
return(EXIT_FAILURE);
  }



if (readfile("ftheta2", &r, &c, &mtheta)!=READFILE_OK) {
  mallocmat(VM_ERRQUIT, 1, &mtheta, 3, 1);
  for (k=0; k<3; k++) {
     mtheta[k][0]=1.0;
  }
} else {
if (r!=3 || c!=1) {
printf("Error: %s is not 2 by 1.\n", "falpha2", K);
return(EXIT_FAILURE);
 }
}
theta1=mtheta[0][0];
theta2=mtheta[0][1];
theta3=mtheta[0][2];


if ((fout=fopen("outlamco12","w"))==NULL) {
     printf("Can't create %s.\n", "outlam2");  
  return(EXIT_FAILURE);
  } 
    

if (outscores==1) {
if ((fscores=fopen("outgc2","w"))==NULL) {
     printf("Can't create %s.\n", "outg2");  
  return(EXIT_FAILURE);
  } 
    }


if ((fexp=fopen("outexpc12","w"))==NULL) {
     printf("Can't create %s.\n", "outexp2");  
  return(EXIT_FAILURE);
  } 
  

if ((fdirich=fopen("outdirichco12","w"))==NULL) {
     printf("Can't create %s.\n", "outdirich2");  
  return(EXIT_FAILURE);
  } 


if ((faccept=fopen("outacceptc12","w"))==NULL) {
     printf("Can't create %s.\n", "outaccept2");  
  return(EXIT_FAILURE);
  } 
  
if ((floglikl=fopen("outlogliklco12","w"))==NULL) {
     printf("Can't create %s.\n", "outloglikl2");  
  return(EXIT_FAILURE);
  } 


if ((fmscores=fopen("outmscoresco12","w"))==NULL) {
     printf("Can't create %s.\n", "outmscores2");  
  return(EXIT_FAILURE);
  } 


if ((fmexp=fopen("outmexpco12","w"))==NULL) {
     printf("Can't create %s.\n", "outmexp2");  
  return(EXIT_FAILURE);
  } 

if ((meanout=fopen("outmlamco12","w"))==NULL) {
     printf("Can't create %s.\n", "outmlam2");  
  return(EXIT_FAILURE);
  } 
  
if ((ftheta=fopen("outthetaco12","w"))==NULL) {
     printf("Can't create %s.\n", "outtheta");  
  return(EXIT_FAILURE);
  } 
    
if ((fspec=fopen("outspec12","w"))==NULL) {
   printf("Can't create %s.\n", "outspec12");  
   return(EXIT_FAILURE);
 } 

mallocImat(VM_ERRQUIT, 4, &Z, N, J, &Nkj, K, J, &Ckj, K, J, &S, N, K);
mallocmat(VM_ERRQUIT, 3, &respprob, R, J, &sumg, N, K, &sumLam, K, J);
mallocvec(VM_ERRQUIT, 9, &pik, K, &fik, K+1, &giknew, K, &probr, R, &sumprobr, R, &ksi, K, &ksinew, K, &pij, K+1,&sumksi, K);
mallocvec(VM_ERRQUIT, 2, &p0, K, &p1, K);

mallocvec(VM_ERRQUIT, 4, &respprob0, J, &respprob1, J, &pij1, J, &pij2, J);

zeromat(sumg,N,K);
zeromat(sumLam,K,J);

zerovec(sumprobr,R);
sumalphaS=0;
zerovec(sumksi,K);

imsl_random_option(6);
imsl_random_seed_set(0);

alphaS = 0;
for (k=0; k<K; k++){
   alphaS = alphaS + alpha[k];
 }
for (k=0; k<K; k++) {
ksi[k] = alpha[k]/alphaS;
}

mallocvec(VM_ERRQUIT, 1, &sumX, N);

m0=0;

zerovec(sumX,N);
for (i=0; i<N; i++){
for (j=0; j<J; j++){
sumX[i] = sumX[i] + X[i][j];}
if (sumX[i]==0) {
  m0=m0+1;
}}

m1=0;
zerovec(sumX,N);
for (i=0; i<N; i++){
for (j=0; j<J; j++){
sumX[i] = sumX[i] + X[i][j];}
if (sumX[i]==J) {
  m1=m1+1;
}}






printf("m0 %d\n",m0);


 n0=round(theta1*N);
 n1=round(theta2*N);

for (n=0; n<num; n++) {

/*
printf("n0initi %d\n",n0);
*/

 if ((m0-n0) < 0) {n0=m0;}
if ((m1-n1) < 0) {n1=m1;}


printf("iteration %d",n);

stop = fopen("stop","r");
if (stop!=NULL) break;


zeroImat(Nkj,K,J);

zeroImat(Ckj,K,J);

zeroImat(S,N,K);

zerovec(pij, K+1);

logp = 0;



for (i=0; i<N-n0-n1; i++){
  for (j=0; j<J; j++){

piksum=0;
fik[0]=0;
Z[i+n0][j]=0;


for (k=0; k<K; k++){
  if (X[i+n0][j]==1) {
    pik[k] = G[i+n0][k]*Lam[k][j];
  } 
else {
    pik[k]=G[i+n0][k]*(1-Lam[k][j]);
  }
 piksum = piksum + pik[k];
 }

imsl_d_random_uniform(1, IMSL_RETURN_USER, &u, 0);

for (k=1; Z[i+n0][j]==0; k++){
  fik[k] = fik[k-1] + pik[k-1]/piksum;

  assert(k<=K);
   
  if (u <= fik[k]) {
      Z[i+n0][j] = k;
      Nkj[k-1][j] = Nkj[k-1][j] + 1;
      Ckj[k-1][j] = Ckj[k-1][j] + X[i+n0][j];
      S[i+n0][k-1] = S[i+n0][k-1]+1;
     }
    }
   }
}


if (fixlambda==0) {
 for (k=0; k<K; k++)
  for (j=0; j<J; j++) {
  imsl_d_random_beta(1, 1.0+Ckj[k][j], 1.0+Nkj[k][j]-Ckj[k][j], IMSL_RETURN_USER, Lam[k]+j, 0); 
  if ((n%thinlam==0)&(n>burnin)) {
   sumLam[k][j] = sumLam[k][j] + Lam[k][j];
 }
  }
}


/* GIBBS sampling for GoM scores */
if (fixgik==0) {
  for (i=0; i<N-n0-n1; i++) {
  giksum = 0;
 for (k=0; k<K; k++) {
  imsl_d_random_gamma(1, S[i+n0][k]+alpha[k], IMSL_RETURN_USER, G[i+n0]+k, 0);
 }


  for (k=0; k<K; k++) {
    giksum=giksum + G[i+n0][k];
   }


 for (k=0; k<K; k++) {
    G[i+n0][k] = G[i+n0][k]/giksum;
    if ((n%thinlam==0)&(n>burnin)) {
      sumg[i+n0][k] = sumg[i+n0][k] + G[i+n0][k];
}
 }


for (j=0; j<J; j++) {
  pij[K] = 0;
  for (k=0; k<K; k++) {
    if (X[i+n0][j]==1) {
    pij[k] = G[i+n0][k]*Lam[k][j];
    } else {
    pij[k] = G[i+n0][k]*(1-Lam[k][j]);
    }
    pij[K] = pij[K]+pij[k];
  }
 logp = logp + log(pij[K]);
}
  }
}
/* end for sampling GoM scores */





Log0=0;
Log1=0;
Logm=0;

 
for (i=1; i<R-1; i++) { 
                                                      
L0sum=0;
L1sum=0;
Lmsum=0;
for (r=0;r<1000;r++)
                                        {

giksum = 0;
for (k=0; k<K; k++) 
           imsl_d_random_gamma(1, alpha[k], IMSL_RETURN_USER, giknew+k, 0);
    for (k=0; k<K; k++) {
     giksum=giksum + giknew[k];
    }
  
for (k=0; k<K; k++) {
     giknew[k] = giknew[k]/giksum;
                     }
  
 L0=1;
for (j=0; j<J; j++) 
                 {
  p0[K] = 0;
for (k=0; k<K; k++) {
  p0[k]=giknew[k]*(1-Lam[k][j]);
       p0[K] = p0[K]+p0[k];

                    }

L0 = L0*p0[K];
                 }

L0sum = L0sum + L0;


L1=1;
for (j=0; j<J; j++) 
                 { 
  p1[K] = 0;
for (k=0; k<K; k++) {
  p1[k]=giknew[k]*Lam[k][j];
       p1[K] = p1[K]+p1[k];

                    }

L1 = L1*p1[K];
                 }

L1sum = L1sum + L1;


Lm=1;
for (j=0; j<J; j++) {
  pij[K] = 0;
  for (k=0; k<K; k++) {
    if (presp[i][j]==1) {
    pij[k] = giknew[k]*Lam[k][j];
    } else {
    pij[k] = giknew[k]*(1-Lam[k][j]);
    }
    pij[K] = pij[K]+pij[k];
                       }

      Lm = Lm*pij[K];
                     }   
                            
                              
Lmsum = Lmsum + Lm;


                                        }
/*
end for r < 1000
*/
L0 = L0sum/1000;
L1 = L1sum/1000;
Lm = Lmsum/1000;

Logm = Logm + presp[i][J]*log(theta3*Lm);   
                                                      

                                                      }                                                   /*end for i=1...  R-1*/

Log0 = m0*log(theta1+theta3*L0); 
Log1 = m1*log(theta2+theta3*L1); 





L = Log0+Log1+Logm;




if (fixalphas==0) {
  ralphaS = 1; 
  imsl_d_random_gamma(1, C1, IMSL_RETURN_USER, &alphaSnew, 0);
  alphaSnew = alphaSnew/(C1/alphaS);

 sumXilogG =0;
 
 for (k=0; k<K; k++) {
   for (i=0; i<N-n0-n1; i++) {
    sumXilogG = sumXilogG + ksi[k]*log(G[i+n0][k]);
   }
 }

 rgamma= imsl_d_gamma(alphaSnew)/imsl_d_gamma(alphaS);
   for (k=0; k<K; k++) {
    rgamma = rgamma*imsl_d_gamma(alphaS*ksi[k])/imsl_d_gamma(alphaSnew*ksi[k]) ;
  }
 ralphaS = ralphaS*pow(alphaSnew/alphaS,A1-1)*pow(exp(-(B1-sumXilogG)*(alphaSnew-alphaS)/(N-n0-n1))*rgamma,N-n0-n1);
 ralphaS = ralphaS*pow(alphaSnew/alphaS,1-2*C1)*exp(-C1*((alphaS/alphaSnew)-(alphaSnew/alphaS)));


 if (ralphaS>=1) {
  alphaS = alphaSnew;
  aSaccept = aSaccept+1;
  }
 else{
  imsl_d_random_uniform(1, IMSL_RETURN_USER, &u, 0);
  if (u <=ralphaS) {
     alphaS = alphaSnew;
    aSaccept = aSaccept+1;
  }
 }
 
if ((n%thinlam==0)&(n>burnin)) {
   sumalphaS = sumalphaS + alphaS;
}


}


if (fixksi==0) {
 for (k=0; k<K; k++) {
  imsl_d_random_gamma(1, C2*K*ksi[k], IMSL_RETURN_USER, ksinew+k, 0);
   }
  ksisum = 0; 
    for (k=0; k<K; k++) {
  ksisum = ksisum + ksinew[k];
    }
     for (k=0; k<K; k++) {
    ksinew[k]=ksinew[k]/ksisum;
     }

rksi=1;
rgamma=1;
for (k=0; k<K; k++) {
    rgamma=rgamma*imsl_d_gamma(alphaS*ksi[k])/imsl_d_gamma(alphaS*ksinew[k]);
      }
  rgamma= pow(rgamma,N-n0-n1);
   rksi= rksi*rgamma;
   for (k=0; k<K; k++) {
    for (i=0; i<N-n0-n1; i++) {
     rksi= rksi*exp(alphaS*log(G[i+n0][k])*(ksinew[k]-ksi[k]));
  } 
   }


for (k=0; k<K; k++) {
    rksi = (rksi*(imsl_d_gamma(C2*K*ksi[k])/imsl_d_gamma(C2*K*ksinew[k])))*(pow(ksi[k],ksinew[k]-1)/pow(ksinew[k],ksi[k]-1));
}
 

if (rksi>=1) {
 for (k=0; k<K; k++) {
  ksi[k] = ksinew[k]; 
    }
  ksiaccept = ksiaccept+1;
  }
 else {
 imsl_d_random_uniform(1, IMSL_RETURN_USER, &u, 0);
 if (u<=rksi) {
    for (k=0; k<K; k++) {
     ksi[k] = ksinew[k];
    }
    ksiaccept = ksiaccept+1;
   }
  }
  
if ((n%thinlam==0)&(n>burnin)) {
for (k=0; k<K; k++) {
      sumksi[k] = sumksi[k] + ksi[k];
}
}
}




for (k=0; k<K; k++) {
  alpha[k] = alphaS*ksi[k]; 
    }

 
/*
Calcul of sensitivity and specificity
*/

for (j=0; j<J; j++) {
    pij1[j] = (theta2/(theta2+theta3*ksi[0]))+Lam[0][j]*((theta3*ksi[0])/(theta2+theta3*ksi[0]));
   pij2[j]=1-Lam[1][j]*((theta3*ksi[1])/(theta1+theta3*ksi[1]));
 }


/*
Update compartmental weights
*/

sumprob0=0;
sumprob1=0;
 for (i=0;i<5000;i++)
   {

giksum = 0;
for (k=0; k<K; k++) 
           imsl_d_random_gamma(1, alpha[k], IMSL_RETURN_USER, giknew+k, 0);
    for (k=0; k<K; k++) {
     giksum=giksum + giknew[k];
    }
  
for (k=0; k<K; k++) {
     giknew[k] = giknew[k]/giksum;
}
  

probr0 = 1.0;
zerovec(respprob0,J);

probr1 = 1.0;
zerovec(respprob1,J);


for (j=0; j<J; j++) {
 for (k=0; k<K; k++) {
 respprob0[j] = respprob0[j] + giknew[k]*(1-Lam[k][j]);    
respprob1[j] = respprob1[j] + giknew[k]*(Lam[k][j]);
 }  
probr0 = probr0*respprob0[j];
probr1 = probr1*respprob1[j];

}
  sumprob0 = sumprob0+probr0;
sumprob1 = sumprob1+probr1;

  /*
printf("sumprobr0:%5.5f\n",sumprob0);
  */  
 }

 probr0=sumprob0/5000;
probr1=sumprob1/5000;

n0mnew = round(probr0*(double)(N-n0-n1));
n1mnew = round(probr1*(double)(N-n0-n1));


 n0=m0-n0mnew;
 n1=m1-n1mnew;
 nmm=N-n0-n1-n0mnew-n1mnew;


 theta1 = n0*0.0002181977;
 theta2 = n1*0.0002181977;
 theta3=  1.0-theta1-theta2;








if ((n%thinlam==0)&(n>burnin)) {
fprintf(ftheta,"%5.5f %5.5f %5.5f\n",theta1,theta2,theta3);
}
	
if ((n%thinlam==0)&(n>burnin)) {
  ndraws = ndraws +1;    
  for (i=0; i<K*J; i++)
    fprintf(fout,"%d %9.8f ", n, Lam[0][i]);

  fprintf(fout,"\n");   
fflush(fout);

 if (n%thinscores==0) {
   if (outscores==1) {
fprintf(fscores,"%d\n",n);   
fprintf(fscores,"ndraws %d\n",ndraws);
   fprintf(fscores,"G");
      for (i=0; i<N; i++) 
        for (k=0; k<K; k++) {
           fprintf(fscores,"%9.8f\n",G[i][k]);
             }
       fprintf(fscores,"\n");
       fflush(fscores);  
        }
 }



 for (j=0; j<J; j++) {
   fprintf(fspec,"%d %9.8f ", n, pij1[j]);
 }
 for (j=0; j<J; j++) {
   fprintf(fspec,"%d %9.8f ", n, pij2[j]);
 }
 fprintf(fspec,"\n");
 fflush(fspec);




    fprintf(fdirich,"%d %9.8f ", n, alphaS);      
      for (k=0; k<K; k++) {
    fprintf(fdirich,"%d %9.8f ", n, ksi[k]);
      }
fprintf(fdirich,"\n");
 fflush(fdirich);

   /* fprintf(faccept,"\n");
    fprintf(faccept,"AR ksi is %9.8f ",ksiaccept/n);
    fprintf(faccept,"\n"); */
    fprintf(floglikl,"%d ",n);
    fprintf(floglikl,"%10.4f  %10.4f",logp,L);
    fprintf(floglikl,"\n");
    fflush(floglikl);

zeromat(respprob,R,J);

giksum = 0;
for (k=0; k<K; k++) 
           imsl_d_random_gamma(1, alpha[k], IMSL_RETURN_USER, giknew+k, 0);
    for (k=0; k<K; k++) {
     giksum=giksum + giknew[k];
    }
  
for (k=0; k<K; k++) {
     giknew[k] = giknew[k]/giksum;
}
  
for (r=0; r<R; r++) {
     probr[r] = 1.0;
     for (j=0; j<J; j++) {
 for (k=0; k<K; k++) {
   if (presp[r][j]==1) {
     respprob[r][j] = respprob[r][j] + giknew[k]*Lam[k][j];
    } else {
      respprob[r][j] = respprob[r][j] + giknew[k]*(1-Lam[k][j]);
    }  
   }
   probr[r] = probr[r]*respprob[r][j];
     }
 sumprobr[r] = sumprobr[r] + probr[r];
}

   for (r=0; r<R; r++) 
 fprintf(fexp,"%13.12f ",probr[r]);
    fprintf(fexp,"\n"); 
    fflush(fexp);
} 
}


aSaccept = aSaccept/num;
ksiaccept = ksiaccept/num;
fprintf(faccept,"overall acceptance ratio for alphaSum is %10.9f ",aSaccept);
    fprintf(faccept,"\n");
fprintf(faccept,"overall acceptance ratio for ksi is %10.9f ",ksiaccept);
fprintf(faccept,"\n");

fprintf(fmscores,"mean Gik");
 fprintf(fmscores,"%d\n",n);
for (i=0; i<N-n0-n1; i++) {
for (k=0; k<K; k++) {
 fprintf(fmscores,"%9.8f ",sumg[i+n0][k]/ndraws);
  }
 fprintf(fmscores,"\n");
}

fprintf(meanout,"meam Lamkj");
 fprintf(meanout,"%d\n",n);
   for (j=0; j<J; j++) {
 for (k=0; k<K; k++) {
 fprintf(meanout,"%9.8f ", sumLam[k][j]/ndraws);
 }
 fprintf(meanout,"\n");
 }
  
fprintf(fdirich,"mean alpha0");
 fprintf(fdirich,"\n");
 fprintf(fdirich,"%9.8f ", sumalphaS/ndraws);
 fprintf(fdirich,"\n");
 
fprintf(fdirich,"mean ksik");
 fprintf(fdirich,"\n");
for (k=0; k<K; k++) {
 fprintf(fdirich,"%9.8f ", sumksi[k]/ndraws);
 }
 fprintf(fdirich,"\n");

for (r=0; r<R; r++) {
 fprintf(fmexp,"%9.8f\n", sumprobr[r]/ndraws);
   }
  fprintf(fmexp,"\n");
  fclose(fout);
 if (outscores==1)
    fclose(fscores);
    fclose(fdirich);
    fclose(fexp);
    fclose(floglikl);
    fclose(fmscores);
    fclose(fmexp);
    fclose(ftheta);
return(EXIT_SUCCESS);}







